package com.tmax.openframe.variable;

import ch.obermuhlner.math.big.BigDecimalMath;
import com.tmax.openframe.variable.group.*;
import java.math.*;
import java.text.DecimalFormat;
import java.util.*;
import java.util.function.BiFunction;
import lombok.*;
import org.apache.commons.lang3.StringUtils;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 */
public class OIVPINQR_VariableContainer {
    public @Getter String WS_TRANS_ID = "OIIQ";
    public @Getter String WS_MAPSET_NAME = "OIVPM03";
    public @Getter String WS_MAP_NAME = "OIVPM03";
    public @Getter @Setter int WS_RESPONSE_CODE;
    public @Getter String WS_COMMUNICATION_AREA = StringUtils.repeat(' ', 1);
    public @Getter @Setter int WS_FIRST_TIME_FLAG;
    public @Getter @Setter OIVPINQR_WS_ERROR_MESSAGE WS_ERROR_MESSAGE = new OIVPINQR_WS_ERROR_MESSAGE();
    public @Getter @Setter OIVPINQR_OIVPM03I OIVPM03I = new OIVPINQR_OIVPM03I();

    public OIVPINQR_OIVPM03O getOIVPM03O() {
        return OIVPINQR_OIVPM03O.builder().FILLER12(getFILLER12())
                .FILLER13(getFILLER13()).DATEO(getDATEO())
                .FILLER14(getFILLER14()).TERMO(getTERMO())
                .FILLER15(getFILLER15()).TIMEO(getTIMEO())
                .FILLER16(getFILLER16()).IDENO(getIDENO())
                .FILLER17(getFILLER17()).NAMEO(getNAMEO())
                .FILLER18(getFILLER18()).DEPTO(getDEPTO())
                .FILLER19(getFILLER19()).PHONO(getPHONO())
                .FILLER20(getFILLER20()).EMALO(getEMALO())
                .FILLER21(getFILLER21()).ADDRO(getADDRO())
                .FILLER22(getFILLER22()).MSGO(getMSGO()).build();
    }

    public void setOIVPM03O(String source) {
        setFILLER12(source.substring(0, 12));
        setFILLER13(source.substring(12, 15));
        setDATEO(source.substring(15, 23));
        setFILLER14(source.substring(23, 26));
        setTERMO(source.substring(26, 30));
        setFILLER15(source.substring(30, 33));
        setTIMEO(source.substring(33, 41));
        setFILLER16(source.substring(41, 44));
        setIDENO(source.substring(44, 52));
        setFILLER17(source.substring(52, 55));
        setNAMEO(source.substring(55, 95));
        setFILLER18(source.substring(95, 98));
        setDEPTO(source.substring(98, 138));
        setFILLER19(source.substring(138, 141));
        setPHONO(source.substring(141, 181));
        setFILLER20(source.substring(181, 184));
        setEMALO(source.substring(184, 224));
        setFILLER21(source.substring(224, 227));
        setADDRO(source.substring(227, 267));
        setFILLER22(source.substring(267, 270));
        setMSGO(source.substring(270, 346));
    }

    public void setOIVPM03O(OIVPINQR_OIVPM03O source) {
        setOIVPM03O(source.toString());
    }

    public String getFILLER12() {
        return getOIVPM03I().getFILLER1();
    }

    public void setFILLER12(String source) {
        OIVPM03I.setFILLER1(source);
    }

    public String getFILLER13() {
        return String.valueOf(getOIVPM03I().getDATEL())
                + getOIVPM03I().getDATEF();
    }

    public void setFILLER13(String source) {
        OIVPM03I.setDATEL(Integer.parseInt(source.substring(0, 2)));
        OIVPM03I.setDATEF(source.substring(2));
    }

    public String getDATEO() {
        return getOIVPM03I().getDATEI();
    }

    public void setDATEO(String source) {
        OIVPM03I.setDATEI(source);
    }

    public String getFILLER14() {
        return String.valueOf(getOIVPM03I().getTERML())
                + getOIVPM03I().getTERMF();
    }

    public void setFILLER14(String source) {
        OIVPM03I.setTERML(Integer.parseInt(source.substring(0, 2)));
        OIVPM03I.setTERMF(source.substring(2));
    }

    public String getTERMO() {
        return getOIVPM03I().getTERMI();
    }

    public void setTERMO(String source) {
        OIVPM03I.setTERMI(source);
    }

    public String getFILLER15() {
        return String.valueOf(getOIVPM03I().getTIMEL())
                + getOIVPM03I().getTIMEF();
    }

    public void setFILLER15(String source) {
        OIVPM03I.setTIMEL(Integer.parseInt(source.substring(0, 2)));
        OIVPM03I.setTIMEF(source.substring(2));
    }

    public String getTIMEO() {
        return getOIVPM03I().getTIMEI();
    }

    public void setTIMEO(String source) {
        OIVPM03I.setTIMEI(source);
    }

    public String getFILLER16() {
        return String.valueOf(getOIVPM03I().getIDENL())
                + getOIVPM03I().getIDENF();
    }

    public void setFILLER16(String source) {
        OIVPM03I.setIDENL(Integer.parseInt(source.substring(0, 2)));
        OIVPM03I.setIDENF(source.substring(2));
    }

    public String getIDENO() {
        return getOIVPM03I().getIDENI();
    }

    public void setIDENO(String source) {
        OIVPM03I.setIDENI(source);
    }

    public String getFILLER17() {
        return String.valueOf(getOIVPM03I().getNAMEL())
                + getOIVPM03I().getNAMEF();
    }

    public void setFILLER17(String source) {
        OIVPM03I.setNAMEL(Integer.parseInt(source.substring(0, 2)));
        OIVPM03I.setNAMEF(source.substring(2));
    }

    public String getNAMEO() {
        return getOIVPM03I().getNAMEI();
    }

    public void setNAMEO(String source) {
        OIVPM03I.setNAMEI(source);
    }

    public String getFILLER18() {
        return String.valueOf(getOIVPM03I().getDEPTL())
                + getOIVPM03I().getDEPTF();
    }

    public void setFILLER18(String source) {
        OIVPM03I.setDEPTL(Integer.parseInt(source.substring(0, 2)));
        OIVPM03I.setDEPTF(source.substring(2));
    }

    public String getDEPTO() {
        return getOIVPM03I().getDEPTI();
    }

    public void setDEPTO(String source) {
        OIVPM03I.setDEPTI(source);
    }

    public String getFILLER19() {
        return String.valueOf(getOIVPM03I().getPHONL())
                + getOIVPM03I().getPHONF();
    }

    public void setFILLER19(String source) {
        OIVPM03I.setPHONL(Integer.parseInt(source.substring(0, 2)));
        OIVPM03I.setPHONF(source.substring(2));
    }

    public String getPHONO() {
        return getOIVPM03I().getPHONI();
    }

    public void setPHONO(String source) {
        OIVPM03I.setPHONI(source);
    }

    public String getFILLER20() {
        return String.valueOf(getOIVPM03I().getEMALL())
                + getOIVPM03I().getEMALF();
    }

    public void setFILLER20(String source) {
        OIVPM03I.setEMALL(Integer.parseInt(source.substring(0, 2)));
        OIVPM03I.setEMALF(source.substring(2));
    }

    public String getEMALO() {
        return getOIVPM03I().getEMALI();
    }

    public void setEMALO(String source) {
        OIVPM03I.setEMALI(source);
    }

    public String getFILLER21() {
        return String.valueOf(getOIVPM03I().getADDRL())
                + getOIVPM03I().getADDRF();
    }

    public void setFILLER21(String source) {
        OIVPM03I.setADDRL(Integer.parseInt(source.substring(0, 2)));
        OIVPM03I.setADDRF(source.substring(2));
    }

    public String getADDRO() {
        return getOIVPM03I().getADDRI();
    }

    public void setADDRO(String source) {
        OIVPM03I.setADDRI(source);
    }

    public String getFILLER22() {
        return String.valueOf(getOIVPM03I().getMSGL())
                + getOIVPM03I().getMSGF();
    }

    public void setFILLER22(String source) {
        OIVPM03I.setMSGL(Integer.parseInt(source.substring(0, 2)));
        OIVPM03I.setMSGF(source.substring(2));
    }

    public String getMSGO() {
        return getOIVPM03I().getMSGI();
    }

    public void setMSGO(String source) {
        OIVPM03I.setMSGI(source);
    }

    public @Getter String DEFINITIONS_OF_EIBAID_FIELD = StringUtils.repeat(' ',
            1);
    public @Getter @Setter OIVPINQR_WS_DATE_TIME_AREA WS_DATE_TIME_AREA = new OIVPINQR_WS_DATE_TIME_AREA();
    public @Getter String TDQ01 = "OIV1";
    public @Getter @Setter int LEN1 = 8;
    public @Getter @Setter int DATALEN = 104;
    public @Getter @Setter OIVPINQR_PEOPLE_INFO_GET PEOPLE_INFO_GET = new OIVPINQR_PEOPLE_INFO_GET();
    public @Getter String START_CODE = StringUtils.repeat(' ', 2);
    public @Getter String DFHCOMMAREA = StringUtils.repeat(' ', 1);
    private final static BiFunction<Long, String, String> intFormatWithSign = (
            value, format) -> {
        DecimalFormat nf = new DecimalFormat();
        nf.applyPattern("+" + format + ";-" + format);
        return nf.format(value);
    };

    public void setWS_TRANS_ID(String source) {
        WS_TRANS_ID = StringUtils.truncate(StringUtils.rightPad(source, 4), 4);
    }

    public void setWS_MAPSET_NAME(String source) {
        WS_MAPSET_NAME = StringUtils.truncate(StringUtils.rightPad(source, 7),
                7);
    }

    public void setWS_MAP_NAME(String source) {
        WS_MAP_NAME = StringUtils.truncate(StringUtils.rightPad(source, 7), 7);
    }

    public String getStringWS_RESPONSE_CODE() {
        return intFormatWithSign.apply((long) WS_RESPONSE_CODE, "00000000");
    }

    public void setWS_COMMUNICATION_AREA(String source) {
        WS_COMMUNICATION_AREA = StringUtils.truncate(
                StringUtils.rightPad(source, 1), 1);
    }

    public String getStringWS_FIRST_TIME_FLAG() {
        return intFormatWithSign.apply((long) WS_FIRST_TIME_FLAG, "0000");
    }

    public void setDEFINITIONS_OF_EIBAID_FIELD(String source) {
        DEFINITIONS_OF_EIBAID_FIELD = StringUtils.truncate(
                StringUtils.rightPad(source, 1), 1);
    }

    public void setTDQ01(String source) {
        TDQ01 = StringUtils.truncate(StringUtils.rightPad(source, 8), 8);
    }

    public String getStringLEN1() {
        return intFormatWithSign.apply((long) LEN1, "0000");
    }

    public String getStringDATALEN() {
        return intFormatWithSign.apply((long) DATALEN, "0000");
    }

    public void setSTART_CODE(String source) {
        START_CODE = StringUtils.truncate(StringUtils.rightPad(source, 2), 2);
    }

    public void setDFHCOMMAREA(String source) {
        DFHCOMMAREA = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }
}
